﻿// Spirals.as
//
// - Jim Bumgardner

SW = Stage.width;
SH = Stage.height;
RAD = Math.min(SW,SH)*.9/2;
degToRad = Math.PI/180;
var deg45 = Math.PI/16;

// Constants for controlling zoom of each spiral
var archK = 2;
var equiK = 2;
var fermatK = SW;

ctr = 0;
descAry = ["Archimede's Spiral\rR = K * A",
		   "Logarithmic Spiral\rR = K ^ A",
		   "Fermat's Spiral\rR = SQRT(K * A)"];

function archimedes(a)
{
	return archK*a;
}

function equiangular(a)
{
	return Math.pow(equiK,a);
}

function fermat(a)
{
	return Math.sqrt(a*fermatK);
}

MovieClip.prototype.drawSpiral = function(radFunc, div)
{
	this.lineStyle(3,0x770077,50);
	var a = 0;
	var r = 0;
	this.moveTo(0,0);
	n = 0;
	var angDiv = 2*Math.PI/div
	while ( r < RAD) 
	{
		var ca = a+angDiv/2;
		var cr = radFunc(ca)/Math.cos(angDiv/2)
		a += angDiv;
		r = radFunc(a);
		this.curveTo(Math.cos(ca)*cr,Math.sin(ca)*cr,
					 Math.cos(a)*r,Math.sin(a)*r);
		// just use this if using line segments only...
		// this.lineTo(Math.cos(a)*r,Math.sin(a)*r);
		++n;
	}
}

function rotator()
{
	this._rotation += this.rd;
	if (this._rotation >= 170) {
		this._rotation = 0;
		this.clear();
		ctr = (ctr + 1) % 3;
		switch (ctr) {
		case 0:	this.drawSpiral(archimedes, 8);		break;
		case 1:	this.drawSpiral(equiangular, 16);	break;
		case 2:	this.drawSpiral(fermat, 	64);	break;
		}
		desc_text.text = descAry[ctr]; 
	}
}

var mc = this.createEmptyMovieClip("mc1", 1);
mc._x = SW/2;
mc._y = SH/2;
mc.drawSpiral(archimedes, 8);
mc.rd = 2;
mc.onEnterFrame = rotator;
desc_text.text = descAry[ctr]; 

